#ifndef __CUDAFullVR_h
#define __CUDAFullVR_h

#include "VolTKCUDAIncludes.h"

class CUDAVolumeTexture;
class CUDATFEmptySpace;
class CUDAGridPartition;
class CUDALut1D;
class CUDAPreintegratedLut;
class BasicLightParam;
class VRSceneParam;
class CUDAVRImage;

class VOLTK_CUDA_API CUDAFullVR
{
public:
	CUDAVolumeTexture* m_Volume;
	CUDATFEmptySpace *m_EmptySpaceTest;
	CUDAGridPartition *m_GridPartition;
	CUDALut1D *m_Lut1D;
	BasicLightParam *m_BasicLightParam;
	VRSceneParam *m_VRSceneParam;
	CUDAVRImage *m_VRImage;
	CUDAPreintegratedLut *m_PreLut;

	int m_CudaBlockSize;
	
	bool m_Shade;
	float m_SampleDistance;
	float m_StdSampleDistance;

	CUDAFullVR();
	~CUDAFullVR();

	void RenderWithoutGridPartition();
	void RenderWithGridPartition();
	void Preintegrated_RenderWithoutGridPartition();
	void Preintegrated_RenderWithGridPartition();
};

#endif
