#include "CUDAFullRayCaster_Preint_basic.cu.h"

static __device__ 
float4 d_CastRay(const float4& voxel_zero,const float4& voxel_unit,const float4& CameraDirection,float tnear,float tfar)
{
	float t0=tnear;
	float4 pos0=voxel_zero + voxel_unit * t0;
	float4 voxel_step=voxel_unit*c_sampleDistance;

	float scalar0;
	float3 k0,b0;

	scalar0=d_GetScalarValue(pos0);
	d_VolumeModel_Shade(pos0,CameraDirection,k0,b0);

	float t1 = t0 + c_sampleDistance;
	float4 pos1 = pos0 +  voxel_step;

	float scalar1;
	float3 k1,b1;

	float4 acc=make_float4(0.0f);
		
	while(t0<tfar && acc.w<0.98f)
    {
		scalar1=d_GetScalarValue(pos1);
		d_VolumeModel_Shade(pos1,CameraDirection,k1,b1);

		float4 col1,col2;
	
		col1=tex2D(TFTex1,scalar1*c_tf_scale+c_tf_shift,scalar0*c_tf_scale+c_tf_shift);
		col2=tex2D(TFTex2,scalar1*c_tf_scale+c_tf_shift,scalar0*c_tf_scale+c_tf_shift);

		if (c_shade)
		{
			col1 = make_float4(make_float3(col1)*k0+b0*col1.w,col1.w);
			col2 = make_float4(make_float3(col2)*k1+b1*col2.w,col2.w);
		}

		acc+=(1.0f-acc.w)*(col1+col2);

		t0 = t1;
		pos0 = pos1;
		scalar0 = scalar1;
		k0=k1;
		b0=b1;

		t1 = t0 + c_sampleDistance;
		pos1 = pos0 +  voxel_step;
    }

	return acc;

}


