#ifndef Abstract_Scene_h
#define Abstract_Scene_h

#include "VolTKSceneIncludes.h"

struct retStatus
{
	retStatus() : redisplay(false), moveMouse(false), moveX(0), moveY(0) {}
	~retStatus() {}

	bool redisplay;
	bool moveMouse;
	int moveX;
	int moveY;
};

class VOLTK_SCENE_API AbstractScene
{
public:
	AbstractScene(){}
	virtual ~AbstractScene(){}

	virtual void Init(){};
	virtual void Render()=0;
	virtual void Resize(int width, int height)=0;
	virtual void Destroy(){};

	virtual void Keyboard ( unsigned char key, int x, int y, retStatus &status) {}
	virtual void KeyboardUp ( unsigned char key, int x, int y, retStatus &status) {}
	virtual void Speckey ( int key, int x, int y, retStatus &status) {}
	virtual void SpecialUp ( int key, int x, int y, retStatus &status) {}
	
	virtual void LButtonDown(int x, int y, retStatus &status){}
	virtual void LButtonUp(int x, int y, retStatus &status){}

	virtual void MButtonDown(int x, int y, retStatus &status){}
	virtual void MButtonUp(int x, int y, retStatus &status){}

	virtual void RButtonDown(int x, int y, retStatus &status){}
	virtual void RButtonUp(int x, int y, retStatus &status){}

	virtual void Wheel(int value, retStatus &status){}
	
	virtual void MouseMove(int x, int y, retStatus &status){}

};

#endif