#ifndef __CUDAMIPVRScene_h
#define __CUDAMIPVRScene_h

#include "Scene.h"
#include "CUDAMIPVR.h"
#include "VolumeData.h"

class VOLTK_SCENE_API CUDAMIPVRScene : public Scene
{
public:
	CUDAMIPVRScene();
	virtual ~CUDAMIPVRScene();

	void SetData(VolumeData *data);
	void SetDataModified();

	void SetWidthCenter(float windowWidth,float windowCenter);
	void SetWindowWidth(float windowWidth);

	void SetWindowCenter(float windowCenter);
	float GetWindowWidth();
	float GetWindowCenter();

	void SetCroppingBounds(const float CroppingBounds[6]);
	void GetCroppingBounds(float CroppingBounds[6]);

	CUDAMIPVR& GetKernelModule() { return m_module; }

protected:
	virtual void RenderContent();
	virtual void GetSize3D(float size[3]);

private:
	VolumeData* m_Data;
	CUDAMIPVR m_module;

	bool m_glewInit;
	bool m_dataModified;

};

#endif
