#ifndef __MIPVRScene_h
#define __MIPVRScene_h

#include "Scene.h"
#include "MIPVR.h"
#include "VolumeData.h"

class CoherentVolume;

class VOLTK_SCENE_API MIPVRScene : public Scene
{
public:
	MIPVRScene();
	virtual ~MIPVRScene();

	void SetData(VolumeData *data);
	void SetDataModified();

	void SetWidthCenter(float windowWidth,float windowCenter);
	void SetWindowWidth(float windowWidth);

	void SetWindowCenter(float windowCenter);
	float GetWindowWidth();

	float GetWindowCenter();

	void SetCroppingBounds(const float CroppingBounds[6]);
	void GetCroppingBounds(float CroppingBounds[6]);

	MIPVR& GetKernelModule() { return m_module; }

	
protected:
	virtual void RenderContent();
	virtual void GetSize3D(float size[3]);

private:
	VolumeData* m_Data;
	MIPVR m_module;
};

#endif
