#ifndef __EndoscopySliceRendering_h
#define __EndoscopySliceRendering_h

#include "VolTKStandardIncludes.h"
#include "Matrix4x4.h"

class CoherentVolume;
class VRImage;

class VOLTK_STANDARD_API EndoscopySliceRendering
{
public:
	EndoscopySliceRendering();
	~EndoscopySliceRendering();

	CoherentVolume* m_Volume;
	VRImage *m_VRImage;
	float m_PixelsToVoxelMatrix[9];

	void CalculatePixelToVoxelMatrix(bool Horizontial, float GridSpacing, Matrix4x4 ViewMatrix);
	
	float m_windowWidth;
	float m_windowCenter;

	float m_CroppingBounds[6];	

	void Render();
};

#endif
