#ifndef __SceneParam_h
#define __SceneParam_h

#include "VolTKStandardIncludes.h"
#include "Quaternion.h"

class VOLTK_STANDARD_API SceneParam
{
public:
	float m_Fovy, m_AspectRatio;
	float m_Near, m_Far;
	
	float m_ZTranslateBase;
	float m_Translate[3];
	float m_Scale;
	Quaternion m_Rotation;	

	SceneParam();
	SceneParam(float fovy, float aspectRatio, const float* size3D);

	~SceneParam(){}

	void InitSceneParam(const float* size3D);

	void InitSceneParam(float fovy, float aspectRatio, const float* size3D);

	void CalculateViewMatrix(Matrix4x4* ViewMatrix) const;
	void CalculateProjectionMatrix(Matrix4x4* ProjectionMatrix) const;
	void CalculateMatrix(Matrix4x4* ViewMatrix, Matrix4x4* ProjectionMatrix) const;

	void MakeReference();

	void Translate(int dx, int dy, const int* viewportSize);
	void Rotate(int dx, int dy, float radPerPixel);
	void Scale(int dy, float scaleRatePerPixel);

	void MoveTo(float x,float y, float z, const float* size3D);

	void Move(float dx, float dy, float dz);
	void Turn(float dx, float dy);
	void Roll(float rad);

private:
	float m_OldTranslate[3];
	float m_OldScale;
	Quaternion m_OldRotation;	

};

#endif