#include "Lut1D.h"
#include <cmath>

static Vector4 *tf_Data;
static int tf_SampleNumber;

#ifndef __BasicTFParam__
#define __BasicTFParam__
static float tf_scale;
static float tf_shift;
#endif 

static float StdSampleDistance;

static inline Vector4 MapScalarToColor(float scalar,float sampleDistance)
{
	float fIndex=scalar*tf_scale+tf_shift;
	int Index1=(int)fIndex;
	float decimal=fIndex-(float)Index1;
	int Index2;

	if (Index1>=0 && Index1<=tf_SampleNumber-2) Index2=Index1+1;
	else if (Index1<0)
	{
		Index1=0;
		Index2=0;
	}
	else if (Index1>=tf_SampleNumber-1)
	{
		Index1=tf_SampleNumber-1;
		Index2=tf_SampleNumber-1;
	}

	Vector4 result1=tf_Data[Index1];
	Vector4 result2=tf_Data[Index2];

	Vector4 result=result1*(1.0f-decimal)+result2*decimal;

	result[3]=result[3]<1.0f? (1.0f-powf(1.0f-result[3],sampleDistance/StdSampleDistance)):1.0f;

	return result;	
}

static inline float GetScalarValue(Vector4 pos);

static inline Vector4 GetColor(Vector4 pos,float sampleDistance)
{
	return MapScalarToColor(GetScalarValue(pos),sampleDistance);
}

static bool TF1DPrepare(const Lut1D *lut,float stdSampleDistance)
{
	if (!lut) return false;

	tf_Data=lut->m_Data;
	tf_SampleNumber=lut->m_SampleNumber;
	tf_scale=(float)(lut->m_SampleNumber-1)/(lut->m_max-lut->m_min);
	tf_shift=-lut->m_min*(lut->m_SampleNumber-1)/(lut->m_max-lut->m_min);
	::StdSampleDistance=stdSampleDistance;

	return true;
}
