#include "TFEmptySpace.h"
#include <cmath>

static float* alphaAccum_data;

#ifndef __BasicTFParam__
#define __BasicTFParam__
static float tf_scale;
static float tf_shift;
#endif 

static inline bool EmptyTest(float minV,float maxV)
{
	int Index1=(int)floorf(minV*tf_scale+tf_shift);
	int Index2=(int)ceilf(maxV*tf_scale+tf_shift);

	return alphaAccum_data[Index2]>alphaAccum_data[Index1];
}

static inline void GetMinMax(int x,int y,int z,float& minV,float& maxV);

static inline bool BlockEmptyTest(int x, int y, int z)
{
	float minV,maxV;
	GetMinMax(x,y,z,minV,maxV);
	return EmptyTest(minV,maxV);
}

static bool TFEmptySpacePrepare(const TFEmptySpace *emptySpace)
{
	if (!emptySpace) return false;

	int sampleNum=emptySpace->m_SampleNumber;
	float minPos=emptySpace->m_min;
	float maxPos=emptySpace->m_max;

	::alphaAccum_data=emptySpace->m_Data;
	
	::tf_scale=(sampleNum-1)/(maxPos-minPos);
	::tf_shift=-(sampleNum-1)*minPos/(maxPos-minPos)+0.5f;
		
	return true;
}


